<?php
/* -*- php -*- ****************************************************************
 *
 *  System        : 
 *  Module        : 
 *  Object Name   : $RCSfile$
 *  Revision      : $Revision$
 *  Date          : $Date$
 *  Author        : $Author$
 *  Created By    : Robert Heller
 *  Created       : Fri Oct 27 20:56:43 2017
 *  Last Modified : <171114.2222>
 *
 *  Description	
 *
 *  Notes
 *
 *  History
 *	
 ****************************************************************************
 *
 *    Copyright (C) 2017  Robert Heller D/B/A Deepwoods Software
 *			51 Locke Hill Road
 *			Wendell, MA 01379-9728
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * 
 *
 ****************************************************************************/

?>
<?php 
  /* Country Robot Theme Widgets */

  class CountryRobot_PageSpecificSidebarButtons extends WP_Widget {
      /* Initialize ourselves */
      function __construct() {
	/* Widget settings. */
        $widget_ops = array( 'classname' => 'PageSpecificSidebarButtons',
			     'description' => __('Display Page Specific Sidebar Buttons', 'country-robot') );
	/* Create the widget. */
	parent::__construct( 'PageSpecificSidebarButtons', 
			  __('Page Specific Sidebar Buttons', 'country-robot'), 
			  $widget_ops);
      }

      /**
	* How to display the widget on the screen. 
 	*/
      function widget( $args, $instance ) {
	extract( $args );
	echo $before_widget;
	echo $before_title . $after_title;
	if ( is_page() || is_single() ) {
	  global $post;
	  $p = $post->ID;
	  $rightbuttons = '';
	  $rightbuttons =  CountryRobot_Theme::get_post_meta($p, '_rightbutton', true);
	  if ( empty($rightbuttons) ) $rightbuttons =  CountryRobot_Theme::get_post_meta($p, 'rightbutton', true);
	  while ( empty($rightbuttons) && $p > 0) {
	    $page = get_page($p);
	    $p = $page->post_parent;
	    $rightbuttons =  CountryRobot_Theme::get_post_meta($p, '_rightbutton', true);
	    if ( empty($rightbuttons) ) $rightbuttons =  CountryRobot_Theme::get_post_meta($p, 'rightbutton', true);
	  }
	  if ( empty($rightbuttons) ) {
	    $page = get_page_by_title('Home');
	    $p = $page->ID;
	    $rightbuttons =  CountryRobot_Theme::get_post_meta($p, '_rightbutton', true);
	    if ( empty($rightbuttons) ) $rightbuttons =  CountryRobot_Theme::get_post_meta($p, 'rightbutton', true);
	  }
	} else {
	  $page = get_page_by_title('Home');
	  $p = $page->ID;
	  $rightbuttons =  CountryRobot_Theme::get_post_meta($p, '_rightbutton', true);
	  if ( empty($rightbuttons) ) $rightbuttons =  CountryRobot_Theme::get_post_meta($p, 'rightbutton', true);
	}
	if ( ! empty($rightbuttons) ) {
	  /*file_put_contents("php://stderr","*** CountryRobot_PageSpecificSidebarButtons::widget: rightbuttons is ".print_r($rightbuttons,true)."\n");*/
	  ?><div id="pagebuttons"><?php 
	  foreach ($rightbuttons as $rightbutton ) {
	    echo $rightbutton;
	    ?><br><?php 
	  }
	  ?></div><?php 
	}
	echo $after_widget;
      }
  }


  class CountryRobot_RelatedLinks extends WP_Widget {
      /* Initialize ourselves */
      function __construct() {
	/* Widget settings. */
	$widget_ops = array( 'classname' => 'RelatedLinks',
			     'description' => __('Related Links', 'country-robot') );
	/* Create the widget. */
	parent::__construct( 'RelatedLinks', __('Related Links', 'country-robot'),
			  $widget_ops);
      }

      /**
	* How to display the widget on the screen. 
 	*/
      function widget( $args, $instance ) {
	extract( $args );
	echo $before_widget;
	echo $before_title . $after_title;
	if ( is_page() || is_single() ) {
	  global $post;
	  $p = $post->ID;
	  $linkcat = '';
	  $linkcat =  CountryRobot_Theme::get_post_meta($p, '_linkcat', false);
	  if ( empty($linkcat) ) $linkcat =  CountryRobot_Theme::get_post_meta($p, 'linkcat', false);
	  while ( empty($linkcat) && $p > 0) {
	    $page = get_page($p);
	    $p = $page->post_parent;
	    $linkcat =  CountryRobot_Theme::get_post_meta($p, '_linkcat', false);
	    if ( empty($linkcat) ) $linkcat =  CountryRobot_Theme::get_post_meta($p, 'linkcat', false);
	  }
	  if ( empty($linkcat) ) {
	    $page = get_page_by_title('Home');
	    $p = $page->ID;
	    $linkcat =  CountryRobot_Theme::get_post_meta($p, '_linkcat', false);
	    if ( empty($linkcat) ) $linkcat =  CountryRobot_Theme::get_post_meta($p, 'linkcat', false);
	  }
	} else {
	  $page = get_page_by_title('Home');
	  $p = $page->ID;
	  $linkcat =  CountryRobot_Theme::get_post_meta($p, '_linkcat', false);
	  if ( empty($linkcat) ) $linkcat =  CountryRobot_Theme::get_post_meta($p, 'linkcat', false);
	}
        if ( ! empty($linkcat) ) {
          /*file_put_contents("php://stderr","*** related links: linkcat is ".$linkcat."\n");*/
	  ?><div id="relatedlinks"><?php 
          wp_list_bookmarks(array(
	  'category_name' => $linkcat,
	  'categorize' => 0,
	  'category_before' => ' ',
	  'category_after' => ' ',
	  'before' => '<li class="therelatedlink">',
	  'title_li' => 'Related Links'));
	  ?></div><?php 
	}
	echo $after_widget;
      }
  }


  class CountryRobot_GoogleAdSense extends WP_Widget {
    function __construct() {
      /* Widget settings. */
      $widget_ops = array( 'classname' => 'dwsgoogleadsense',
			   'description' => 
				__('Display Google Ad Sense Blocks', 
					'country-robot') );
      $control_ops = array( 'width' => 300, 'height' => 350,
			    'id_base' => 'dwsgoogleadsense');
      /* Create the widget. */
      $this->WP_Widget( 'dwsgoogleadsense',
			   __('Display Google Ad Sense Blocks', 'country-robot'),
			   $widget_ops, $control_ops );
    }
    /**
     * How to display the widget on the screen.
     */
    function widget( $args, $instance ) {
      extract( $args );
      /* Before widget (defined by themes). */
      echo $before_widget;
      switch (CountryRobot_Theme::googleAdType()) {
      case 's':
        ?><script type="text/javascript"><!--
                  google_ad_client = "<?php echo CountryRobot_Theme::googleAdClient(); ?>";
                  google_ad_slot = "<?php echo $instance['google_ad_slot']; ?>";
                  google_ad_width = <?php echo $instance['google_ad_width']; ?>;
                  google_ad_height = <?php echo $instance['google_ad_height']; ?>;
                  //--> 
          </script>
          <script type="text/javascript"
           src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
          </script><?php
         break;
      case 'a':
        ?><script async src="//pagead2.googlesyndication.com/pagead/js/adsbygoogle.js"></script>
          <ins class="adsbygoogle"
             style="display:inline-block;width:<?php echo $instance['google_ad_width']; ?>px;height:<?php echo $instance['google_ad_height']; ?>px"
             data-ad-client="<?php echo CountryRobot_Theme::googleAdClient(); ?>"
             data-ad-slot="<?php echo $instance['google_ad_slot']; ?>"></ins>
          <script>
            (adsbygoogle = window.adsbygoogle || []).push({});
          </script><?php
        break;
      }
      /* After widget (defined by themes). */
      echo $after_widget;
    }
    static function shortcode ($atts, $content=null, $code="") {
      extract( shortcode_atts ( array(
	'google_ad_slot' => '',
	'google_ad_width' => 0,
	'google_ad_height' => 0), $atts ) );
      switch (CountryRobot_Theme::googleAdType()) {
      case 's':
        $result  = '<script type="text/javascript"><!--
                      google_ad_client = "'.CountryRobot_Theme::googleAdClient().'";
                      google_ad_slot = "'.$google_ad_slot.'";
                      google_ad_width = '.$google_ad_width.';
                      google_ad_height = '.$google_ad_height.';
                      //-->
                    </script>
                    <script type="text/javascript"
                       src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
                    </script>';
         break;
       case 'a':
         $result  = '<script async src="//pagead2.googlesyndication.com/pagead/js/adsbygoogle.js"></script>
          <ins class="adsbygoogle"
             style="display:inline-block;width:'.$google_ad_width.'px;height:'.$google_ad_height.'px"
             data-ad-client="'.CountryRobot_Theme::googleAdClient().'"
             data-ad-slot="'.$google_ad_slot.'"></ins>
          <script>
             (adsbygoogle = window.adsbygoogle || []).push({});
          </script>';
         break;
      }
      return $result;
    }
    /**
     * Update the widget settings.
     */
    function update( $new_instance, $old_instance ) {
      $instance = $old_instance;
      $instance['google_ad_slot'] = $new_instance['google_ad_slot'];
      $instance['google_ad_width'] = $new_instance['google_ad_width'];
      $instance['google_ad_height'] = $new_instance['google_ad_height'];
      return $instance;
    }
    /**
     * Displays the widget settings controls on the widget panel.
     * Make use of the get_field_id() and get_field_name() function
     * when creating your form elements. This handles the confusing stuff.
     */
    function form( $instance ) {
      /* Set up some default widget settings. */
      $defaults = array( 'google_ad_slot' => "", 
			 'google_ad_width' => 0,
			 'google_ad_height' => 0 );
      $instance = wp_parse_args( (array) $instance, $defaults ); ?>
      <p>
	<label for="<?php echo $this->get_field_id( 'google_ad_slot' ); 
	?>"><?php _e('Google Ad Slot','country-robot'); ?></label>
	<input id="<?php echo $this->get_field_id( 'google_ad_slot' ); ?>"
	       value="<?php echo $instance['google_ad_slot']; ?>"
	       name="<?php echo $this->get_field_name( 'google_ad_slot' ); ?>"
	       style="width:100%;" />
      </p>
      <p>
	<label for="<?php echo $this->get_field_id( 'google_ad_width' ); 
	?>"><?php _e('Google Ad Width','country-robot'); ?></label>
	<input id="<?php echo $this->get_field_id( 'google_ad_width' ); ?>"
	       value="<?php echo $instance['google_ad_width']; ?>"
	       name="<?php echo $this->get_field_name( 'google_ad_width' ); ?>"
	       style="width:100%;" />
      </p>
      <p>
	<label for="<?php echo $this->get_field_id( 'google_ad_height' ); 
	?>"><?php _e('Google Ad Height','country-robot'); ?></label>
	<input id="<?php echo $this->get_field_id( 'google_ad_height' ); ?>"
	       value="<?php echo $instance['google_ad_height']; ?>"
	       name="<?php echo $this->get_field_name( 'google_ad_height' ); ?>"
	       style="width:100%;" />
      </p>
      <?php
    }
  }


  add_shortcode('CR_AdSense',array('CountryRobot_GoogleAdSense','shortcode'));
